% script for loading data (inspired in neurofinder)
% first you need to unzip the images.zip files in the image subfolder for
% each dataset, then you can run this script to load the tiff
% requires one package from the matlab file exchange
%
% - jsonlab
% - http://www.mathworks.com/matlabcentral/fileexchange/33381-jsonlab--a-toolbox-to-encode-decode-json-files-in-matlab-octave
%

%% find tiff files and order them
zip_filename = fullfile('N.02.00','images','images','*.tif')
xlsfiles = dir(zip_filename);
xlsfiles = {xlsfiles.name};
xlsfiles = sort(xlsfiles);
numframes = numel(xlsfiles);
%% load moviee in the mov variable
mov = [];
for counter = 1:numframes
    files = xlsfiles{counter};
    if isempty(mov)
        img = imread(fullfile('N.02.00','images','images',files));
        mov = zeros(size(img,1),size(img,2),numframes);
    else
        mov(:,:,counter) = imread(fullfile('N.02.00','images','images',files));
    end
    if mod(counter,100)==0
       disp(counter) 
    end
end

%% load the regions (training data only)
[w, h, t] = size(mov);
regions = loadjson(fullfile('N.02.00','regions','consensus_regions.json'));
masks = zeros(w, h);

for i = 1:length(regions)
	if isstruct(regions)
		coords = regions(i).coordinates;
	elseif iscell(regions)
		coords = regions{i}.coordinates;
	end
	masks(sub2ind([w, h], coords(:,1), coords(:,2))) = 1;
end

%% show the outputs
figure();
subplot(1,2,1);
imagesc(mean(mov,3)); axis image off;
subplot(1,2,2);
imagesc(masks); axis image off;